/******************************************************************/
/* VPoker Installation Program                                    */
/* By Brett King                                                  */
/* (c) Copyright International Business Machines Corporation 1994 */
/* All rights Reserved.                                           */
/******************************************************************/
call RxFuncAdd SysLoadFuncs, RexxUtil, SysLoadFuncs
call SysLoadFuncs

say 'VPoker Installation Program'
say 'By Brett King'
say '(c) Copyright International Business Machines Corporation 1994'
say 'All rights Reserved.'

'@echo off'
movecmd = 'MOVE '
say "Creating CARDFACE directory..."
rc = SysMkDir('CARDFACE')
if rc <> 0 then
do
   call cleanup "ERROR - Unable to create CARDFACE directory"
   return
end
'MOVE card*.bmp cardface'
if rc <> 0 then
do
   call cleanup "ERROR - Unable to move CARD*.BMP"
   return
end
say "Creating SOUNDS directory..."
rc = SysMkDir('SOUNDS')
if rc <> 0 then
do
   call cleanup "ERROR - Unable to create SOUNDS directory"
   return
end
'MOVE sound*.wav sounds'
if rc <> 0 then
do
   call cleanup "ERROR - Unable to move SOUND file"
   return
end
say "Renaming temporary files..."
'ren CARDBAC*.BM@ CARDBAC*.BMP'
if rc <> 0 then
do
   call cleanup "ERROR - Unable to ren CARDBAC.BM@"
   return
end
'ren VPOKER.EX@ VPOKER.EXE'
if rc <> 0 then
do
   call cleanup "ERROR - Unable to ren VPOKER.EX@"
   return
end
say "Adding program object to Games folder..."
fspec=directory()
fspec=fspec||'\VPOKER.EXE'
setup='EXENAME='||fspec||';PARAMETERS=;MINIMIZED=;ASSOCFILTER=;'
title = 'VPoker'
classname = 'WPProgram'
location = '<WP_GAMES>'
result = SysCreateObject(classname, title, location, setup)
If result<>1 then
do
   say "Warning - Unable to create program object."
   say "Create a program object for VPOKER manually."
   say "Type VPOKER to run."
   return
end
say "Installation Complete!"
say "Type VPOKER to run, or run from the icon in the"
say "Games folder."
return

cleanup:
   parse arg msg
   say msg
   say "Cleanup the current directory.  Unzip VPOKER.ZIP again,"
   say "and retry the installation."
   return

